<?php

	// check acces authorization
	session_start();
	if($_SESSION['user']!="admin"){
		echo "Unauthorized access.";
		die();
	}
	
	// load core files
	include("../../../config.php");
	include("../../../css/design.php");
	include("../../../header.php");
	



?>
<!DOCTYPE html>
<html>
	<head>
		<title><?php echo $pageName?></title>
		<?php metaHeader()?>
		<style>
			.dynamicTextSetupTable td{
				vertical-align: top;
			}
			.button2{
				cursor: auto;
			}
		.alertGreen{
			color:#00ff00;
		}
		.alertOrange{
			color:#ffa500;
		}
		.alertRed{
			color:#ff0000;
		}
		@-webkit-keyframes trafficAlertAnimation {
		    0% {
				-webkit-transform: scale(0.7, 0.7); opacity: 0.6;
			}
		    50% {
				opacity: 1.0;
				-webkit-transform: scale(1.2, 1.2);
			}
		    100% {
				-webkit-transform: scale(0.7, 0.7); opacity: 0.6;
			}
		}
		@keyframes trafficAlertAnimation {
		    0% {
				-webkit-transform: scale(0.7, 0.7); opacity: 0.6;
				transform: scale(0.7, 0.7); opacity: 0.6;
			}
		    50% {
				opacity: 1.0;
				-webkit-transform: scale(1.2, 1.2);
				transform: scale(1.2, 1.2);
			}
		    100% {
				-webkit-transform: scale(0.7, 0.7); opacity: 0.6;
				transform: scale(0.7, 0.7); opacity: 0.6;
			}
		}
		.trafficAlertAnimationClass{
			-webkit-animation: trafficAlertAnimation 5s ease-out;
	    	-webkit-animation-iteration-count: infinite;
			animation: trafficAlertAnimation 5s ease-out;
	    	animation-iteration-count: infinite;
		}
		td {
			text-align:left;
			vertical-align:middle;
			padding-left:10px;
		}
		.panelGreen {
			background:#004d00;	
		}
		.panelOrange {
			background:#b34700;
		}
		.panelRed {
			background:#800000;
		}
		
		.previewPanel {
			margin: 0 auto;
			margin-bottom: 10px;
			border: 0px solid #303F9F;
			background: #0D47A1;
			border-radius: 0px;
			padding: 0px;
			padding-top: 5px;
			padding-bottom: 5px;
			position: relative;
			padding-left:20px;
			padding-right:30px;
		}
		
		.mapPanel {
			width: 98%;
			height: 400px;
			width: 400px;
			margin: 20px auto;
			border: 2px solid white;
			border-radius: 10px;			
		}
		</style>
		<script src="https://maps.googleapis.com/maps/api/js?key=<?php echo $googleMapsAPIKey?>"></script>	
	</head>
	<body>

	<script>
	<?php
		// check if settings already exists and if so, load it, otherwise set parameters to default values
	if(file_exists("settings.txt")){
		$variables = json_decode(file_get_contents("settings.txt"),true);
	}
    ?>
	function loadAlerts(){
	<?php	
	
	for ($i = 1; $i <= $variables["numTrafficAlerts"]; $i++) {
		echo 'addAlert();'.PHP_EOL;
	}
	foreach($variables as $key=>$value){
		${$key} = $value;
		echo '$(\'#';
		echo $key;
		echo '\').val(\'';
		echo $value;
		echo '\');'.PHP_EOL;		
	}
	for ($i = 1; $i <= $variables["numTrafficAlerts"]; $i++) {
		// route
		// green, orange, red
		// map refresh
		
		echo 'getTraffic('.$i.');'.PHP_EOL;
		echo 'updateShowRoute('.$i.');'.PHP_EOL;	
		echo 'updateMap('.$i.');'.PHP_EOL;
		echo 'updatePreview(\'Green\','.$i.');'.PHP_EOL;
		echo 'updatePreview(\'Orange\','.$i.');'.PHP_EOL;
		echo 'updatePreview(\'Red\','.$i.');'.PHP_EOL;
		if ($variables["routeActive".$i]=="false") echo '$(\'#routePanel'.$i.'\').hide();'.PHP_EOL;
		if ($variables["routeGreenActive".$i]=="false") echo '$(\'#routeGreenPanel'.$i.'\').hide();'.PHP_EOL;
		if ($variables["routeOrangeActive".$i]=="false") echo '$(\'#routeOrangePanel'.$i.'\').hide();'.PHP_EOL;
		if ($variables["routeRedActive".$i]=="false") echo '$(\'#routeRedPanel'.$i.'\').hide();'.PHP_EOL;
		
	}
	?>
	}
	var alertNum=0;
	var markers= { };
	var maps= { };
	var lastMarker= { };
	var directions= { };
	

	
	function getTraffic(myAlertNum) {		
    var directionsService = new google.maps.DirectionsService();
    directionsService.route({
            origin: {
              lat: Number($('#routeOriginLat'+myAlertNum).val()),
              lng: Number($('#routeOriginLng'+myAlertNum).val())
			},
			destination: {
              lat: Number($('#routeDestinationLat'+myAlertNum).val()),
              lng: Number($('#routeDestinationLng'+myAlertNum).val())
		  },
            travelMode: "DRIVING",
			durationInTraffic: true
        },
        function(response, status) {
            if (status === google.maps.DirectionsStatus.OK) {
				console.log(response);
                tiempo = response.routes[0].legs[0].duration.value;
                tiempoString = response.routes[0].legs[0].duration.text;
				traf= response.routes[0].legs[0].duration_in_traffic.text;
				trafV= response.routes[0].legs[0].duration_in_traffic.value;
				console.log('Tiempo driving'+tiempo);
                $('#normalDrivingTime'+myAlertNum).html(tiempoString + ' ('+tiempo+'s)');
				$('#currentDrivingTime'+myAlertNum).html(traf + ' ('+trafV+'s)');

				if ($('#showRoute'+myAlertNum).val()=='true') {				
					directions['directions'+myAlertNum].setDirections(response);
					directions['directions'+myAlertNum].setMap(maps['map'+myAlertNum]);
				}
				else{
					directions['directions'+myAlertNum].setMap(null);
				}

            } else {
                $('#currentDrivingTime'+myAlertNum).html("Error while loading driving time");
				$('#normalDrivingTime'+myAlertNum).html("Error while loading driving time");
            }
        });
}
	function updateShowRoute(myAlertNum){		
		if ($('#showRoute'+myAlertNum).val()=='true') {	
			directions['directions'+myAlertNum].setMap(maps['map'+myAlertNum]);				
		}
		else{
			directions['directions'+myAlertNum].setMap(null);
		}
	}
	
	function centerMapStation(myAlertNum) {
		markers['markerCenterMap'+myAlertNum].setPosition({
		  lat: <?php echo $stationLat;?>,
		  lng: <?php echo $stationLon;?>
		});
		maps['map'+myAlertNum].setCenter({
		  lat: <?php echo $stationLat;?>,
		  lng: <?php echo $stationLon;?>
		});
	}
		
	function updateMap(myAlertNum) {
		
		maps['map'+myAlertNum].setCenter({
		  lat: Number($('#centerMapLat'+myAlertNum).val()),
		  lng: Number($('#centerMapLong'+myAlertNum).val())
		});		  

		markers['markerCenterMap'+myAlertNum].setPosition({
		  lat: Number($('#centerMapLat'+myAlertNum).val()),
		  lng: Number($('#centerMapLong'+myAlertNum).val())
		});
		markers['markerStart'+myAlertNum].setPosition({
		  lat: Number($('#routeOriginLat'+myAlertNum).val()),
		  lng: Number($('#routeOriginLng'+myAlertNum).val())
		});
		markers['markerFinish'+myAlertNum].setPosition({
		  lat: Number($('#routeDestinationLat'+myAlertNum).val()),
		  lng: Number($('#routeDestinationLng'+myAlertNum).val())
		});

		maps['map'+myAlertNum].setZoom(Number($('#zoomMap'+myAlertNum).val()));
		getTraffic(myAlertNum);
		google.maps.event.trigger(maps['map'+myAlertNum], 'resize');
				
		
	}
	
	function initMap(myAlertNum) {	     
		 
	  var map = new google.maps.Map(document.getElementById('routeMap'+myAlertNum), 
		  {
		  zoom: Number($('#zoomMap'+myAlertNum).val()),
          center: {
              lat: Number($('#centerMapLat'+myAlertNum).val()),
              lng: Number($('#centerMapLong'+myAlertNum).val())
          }
		});
		var trafficLayer = new google.maps.TrafficLayer();
		trafficLayer.setMap(map);
		
		directionsDisplay = new google.maps.DirectionsRenderer({suppressMarkers: true});		
		directionsDisplay.setMap(map);
		directions['directions'+myAlertNum]=directionsDisplay;
		
				
		var iconCenter = {
			url: 'icons/center.png', // url
			scaledSize: new google.maps.Size(25, 25), // scaled size
			origin: new google.maps.Point(0,0), // origin
			anchor: new google.maps.Point(12, 12) // anchor
		};

		var iconStart = new google.maps.MarkerImage("http://chart.apis.google.com/chart?chst=d_map_pin_letter&chld=S|00FF00",
        new google.maps.Size(21, 34),
        new google.maps.Point(0,0),
        new google.maps.Point(10, 34)
		);
		
		var iconFinish = new google.maps.MarkerImage("http://chart.apis.google.com/chart?chst=d_map_pin_letter&chld=F|FF0000",
        new google.maps.Size(21, 34),
        new google.maps.Point(0,0),
        new google.maps.Point(10, 34)
		);
		
		/*var iconStart = {
			url: 'http://chart.apis.google.com/chart?chst=d_map_pin_letter&A|FF0000|000000', // url
			scaledSize: new google.maps.Size(25, 25), // scaled size
			origin: new google.maps.Point(0,0), // origin
			anchor: new google.maps.Point(7, 21) // anchor
		};*/
		var markerCenterMap = new google.maps.Marker({
		  icon : iconCenter,
          position: {
              lat: Number($('#centerMapLat'+myAlertNum).val()),
              lng: Number($('#centerMapLong'+myAlertNum).val())
          },
          map: map,
          title: 'Left Click to center'
        });
		markers['markerCenterMap'+myAlertNum]=markerCenterMap;
		
		var markerStart = new google.maps.Marker({
		  icon : iconStart,		  
          position:  {
              lat: Number($('#routeOriginLat'+myAlertNum).val()),
              lng: Number($('#routeOriginLng'+myAlertNum).val())
		  },
          map: map,
          title: 'Right-click to place route origin and destination'
        });
		markers['markerStart'+myAlertNum]=markerStart;
		
		var markerFinish = new google.maps.Marker({
		  icon : iconFinish,		  
          position:  {
              lat: Number($('#routeDestinationLat'+myAlertNum).val()),
              lng: Number($('#routeDestinationLng'+myAlertNum).val())
		  },
          map: map,
          title: 'Right-click to place route origin and destination'
        });
		markers['markerFinish'+myAlertNum]=markerFinish;
		
		
		map.addListener('click', function(e) {
			map.setCenter(e.latLng);
			$('#centerMapLat'+myAlertNum).val(e.latLng.lat());
			$('#centerMapLong'+myAlertNum).val(e.latLng.lng());
            //placeMarkerAndPanTo(e.latLng, map);
			markers['markerCenterMap'+myAlertNum].setPosition(e.latLng );			
        });
		map.addListener('rightclick', function(e) {
			var lat = e.latLng.lat();
			var lng = e.latLng.lng();	
			
			if (lastMarker['map'+myAlertNum]==0) {
				 markers['markerFinish'+myAlertNum].setPosition({
				  lat: lat,
				  lng: lng
				});
				$('#routeDestinationLat'+myAlertNum).val(e.latLng.lat());
				$('#routeDestinationLng'+myAlertNum).val(e.latLng.lng());
				lastMarker['map'+myAlertNum]=1;
				getTraffic(myAlertNum);	
			}
			else
			{
				markers['markerStart'+myAlertNum].setPosition({
				  lat: lat,
				  lng: lng
				});
				$('#routeOriginLat'+myAlertNum).val(e.latLng.lat());
				$('#routeOriginLng'+myAlertNum).val(e.latLng.lng());
				lastMarker['map'+myAlertNum]=0;
				getTraffic(myAlertNum);	
				
			}
		
		});
		google.maps.event.addListener(map, 'zoom_changed', function() {
			$('#zoomMap'+myAlertNum).val(map.getZoom());    
		});
		maps['map'+myAlertNum]=map;
		lastMarker['map'+myAlertNum]=1;
		getTraffic(myAlertNum);		
		
	}
	
	function deleteAlert(myAlertNum){
		if (confirm('Are you sure you want to delete Traffic alert #'+myAlertNum+' - '+$('#routeName'+myAlertNum).val())) {
			$('#route'+myAlertNum).remove();
			alertNum--;
			$('#numTrafficAlerts').val(myAlertNum);
			if(alertNum>0){
				$('#deleteAlert'+myAlertNum).show();
			}
		}
	}
	function updatePreview(myColor, myAlertNum)
	{
	 iconElement='#previewAlert'+myColor+'Icon'+myAlertNum;
	 textElement='#previewAlert'+myColor+'Text'+myAlertNum;
	 routeName = $('#routeName'+myAlertNum).val();
	 iconValue = 'alert'+myColor+' '+$('#route'+myColor+'Icon'+myAlertNum).val();
	 textValue = $('#route'+myColor+'Text'+myAlertNum).val();
	 timeValue = $('#route'+myColor+'Value'+myAlertNum).val(); 
	 timeText = Math.round(timeValue/60)+' min';
	 textValue = textValue.replace('%T', timeText+' min');
     textValue = textValue.replace('%S', timeValue);
	 myMessage ='<span> '+routeName + ': ' + textValue+'</span>';

	 $(iconElement).attr("class",iconValue);
	 if ( $('#icon'+myColor+'Animated'+myAlertNum).val()=='true') {
		$(iconElement).addClass("trafficAlertAnimationClass");	
	}
	  
	 $(textElement).html(myMessage);
	}
	function addAlert(){
		alertNum++;
		var alertString = '<div style="border-bottom: 1px solid white;" id="route'+alertNum+'">';
		alertString+='<h3>Traffic Alert #'+alertNum+'</h3><br>Route Name : <input id="routeName'+alertNum+'" name="routeName'+alertNum+'" class="button2"  value="Route'+alertNum+'"/>  ';
		alertString+='<select id="routeActive'+alertNum+'" name="routeActive'+alertNum+'" onChange="$(\'#routePanel'+alertNum+'\').toggle();updateMap('+alertNum+');" class="button2">';
		alertString+='<option value="true" selected>Enabled</option>';
		alertString+='<option value="false">Disable</option>';
		alertString+='</select>';
		alertString+='Cache delay (min) : <input id="routeName'+alertNum+'CacheDelay" name="routeName'+alertNum+'CacheDelay" class="button2"  value="10"/>  ';
		alertString+='    <span id="deleteAlert'+alertNum+'" class="button2 fa fa-trash" onClick="deleteAlert('+alertNum+');"> Delete   </span><br/><br/>';
		alertString+='<div id="routePanel'+alertNum+'">';
		alertString+='<b>Google Maps with traffic : </b>';
		alertString+='<select id="routeMapActive'+alertNum+'" name="routeMapActive'+alertNum+'" class="button2">';
		alertString+='<option value="alertDetails" selected>Alert Details</option>';
		alertString+='<option value="alertFixed">Alert Fixed</option>';
		alertString+='<option value="alwaysFixed">Always Fixed</option>';
		alertString+='<option value="disabled">Disabled</option>';
		alertString+='</select> ';
		alertString+=' Show route on Map : ';
		alertString+='<select id="showRoute'+alertNum+'" name="showRoute'+alertNum+'" class="button2" onChange="updateShowRoute('+alertNum+')">';
		alertString+='<option value="true" selected>Yes</option>';
		alertString+='<option value="false">No</option>';
		alertString+='</select> <br/> ';
		alertString+='<span class="fa fa-info-circle"></span> Alert Details = If alert triggered, the user can click on "More" to display the map. Alert Fixed = the Map is always displayed below the alert. Always Fixed = the Map is always displayed<br/>';	
		alertString+='<table border="0">';
		alertString+='<tr><td rowspan="8"><div id="routeMapPanel'+alertNum+'">'; // Route Map Panel
		alertString+='<div class="mapPanel" id="routeMap'+alertNum+'"></div>';
		alertString+='</div></td>'; // end of Route Map Panel
		alertString+='<td colspan="2"><span class="fa fa-info-circle"></span> Enter values and refresh map or directly use the map as follows :';
		alertString+='<ul><li>Left-click on the Map to set center.</li><li>Right-click to place Route Origin and Destination (1st click = Origin, 2nd click = Destination).</li><li> Zoom to update zoom.</li></ul></td></tr>';
		alertString+='<tr><td><span class="mticon-time"></span> Current driving time : </td><td><span id="currentDrivingTime'+alertNum+'">3min (180s).</span></td></tr>';
		alertString+='<tr><td><span class="mticon-time"></span> Normal driving time : </td><td><span id="normalDrivingTime'+alertNum+'">3min (180s).</span></td></tr>';
		alertString+='<tr><td><img style="vertical-align: middle" src="http://chart.apis.google.com/chart?chst=d_map_pin_letter&chld=S|00FF00" width="21" height="34"/> Route Origin : </td><td>Lat <input id="routeOriginLat'+alertNum+'" size="9" name="routeOriginLat'+alertNum+'" class="button2"  value="41.391334"/>   ';
		alertString+='Lng <input id="routeOriginLng'+alertNum+'" size="9" name="routeOriginLng'+alertNum+'" class="button2"  value="1.965843"/> </td></tr>'; 
		alertString+='<tr><td><img style="vertical-align: middle" src="http://chart.apis.google.com/chart?chst=d_map_pin_letter&chld=F|FF0000" width="21" height="34"/> Route Destination : </td><td>Lat <input id="routeDestinationLat'+alertNum+'" size="9" name="routeDestinationLat'+alertNum+'" class="button2"  value="41.388217"/>   '; 
		alertString+='Lng <input id="routeDestinationLng'+alertNum+'" size="9" name="routeDestinationLng'+alertNum+'" class="button2"  value="1.9459173"/> </td></tr>';
		alertString+='<tr><td><img style="vertical-align: middle" src="icons/center.png" width="25" height="25"/> Map Center</td><td> Lat <input id="centerMapLat'+alertNum+'" size="9" name="centerMapLat'+alertNum+'" class="button2"  value="41.390476"/>   '; 
		alertString+='Lng <input id="centerMapLong'+alertNum+'" size="9" name="centerMapLong'+alertNum+'" class="button2"  value="1.958249"/> </td></tr>  ';
		alertString+='<tr><td>Zoom : </td><td><input id="zoomMap'+alertNum+'" size="2" name="zoomMap'+alertNum+'" class="button2"  value="13"/>  ';
		alertString+='<span class="fa fa-info-circle"></span> Zoom between 1 and 22.</td></tr>';			
		alertString+='<tr><td colspan="2" style="text-align:center"><span id="refreshMap'+alertNum+'" class="button2 fa fa-refresh" onClick="updateMap('+alertNum+');"> Refresh Map </span>    ';
		alertString+='<span id="refreshMap'+alertNum+'" class="button2 mticon-station" onClick="centerMapStation('+alertNum+');"> Center on Station </span></td></tr> ';	
	
		alertString+='</table>';
		// Green Alert
		alertString+='<b>Green level alert:</b>  ';
		alertString+='<select id="routeGreenActive'+alertNum+'" name="routeGreenActive'+alertNum+'" onChange="$(\'#routeGreenPanel'+alertNum+'\').toggle();" class="button2">';
		alertString+='<option value="true" selected>Enabled</option>';
		alertString+='<option value="false">Disable</option>';
		alertString+='</select>';	
		alertString+='<div id="routeGreenPanel'+alertNum+'">'; // Green Panel
		alertString+='<table width="100%" style="text-align:left">';
		alertString+='<tr ><td width="20px" rowspan="4" class="panelGreen"></td><td style="text-align:left">Green level route time (s): </td><td><input id="routeGreenValue'+alertNum+'" name="routeGreenValue'+alertNum+'" size="4" class="button2"  value="0"/>   '; 
		alertString+='<span class="fa fa-info-circle"></span> In seconds. If driving time returned by Google Directions is <b>below</b> that thresold, the Green alert will be displayed</td></tr>';		
		alertString+='<tr><td style="text-align:left">Green level icon : </td><td><input id="routeGreenIcon'+alertNum+'" name="routeGreenIcon'+alertNum+'" class="button2"   onChange="updatePreview(\'Green\','+alertNum+');" value="fa fa-automobile"/> ';
		alertString+='Animated : <select id="iconGreenAnimated'+alertNum+'" name="iconGreenAnimated'+alertNum+'" onChange="updatePreview(\'Green\','+alertNum+');" class="button2">';
		alertString+='<option value="true">True</option>';
		alertString+='<option value="false" selected>False</option>';
		alertString+='</select></td></tr>';
		alertString+='<tr><td>Green level message : </td><td><input id="routeGreenText'+alertNum+'" size="60" name="routeGreenText'+alertNum+'" class="button2"   onChange="updatePreview(\'Green\','+alertNum+');" value="Green Alert Message %T to travel (%S s)"/><br/>  '; 
		alertString+='<span class="fa fa-info-circle"></span> You can use %T for driving time in seconds and %S for driving time as text return by google (e.g. 2 min).</td></tr>';	
		alertString+='<tr><td>Green Alert preview : </td><td class="previewPanel"><span id="previewAlertGreenIcon'+alertNum+'" class="alertGreen fa fa-automobile">&nbsp;</span><span id="previewAlertGreenText'+alertNum+'"> Route'+alertNum+': Green Alert Message 2 min to travel (100 s)</span></td></tr>';
		alertString+='</table><br/></div>'; // end of Green panel
		// end of Green Alert
		// Orange Alert
		alertString+='<b>Orange level alert:</b>  ';
		alertString+='<select id="routeOrangeActive'+alertNum+'" name="routeOrangeActive'+alertNum+'" onChange="$(\'#routeOrangePanel'+alertNum+'\').toggle();" class="button2">';
		alertString+='<option value="true" selected>Enabled</option>';
		alertString+='<option value="false">Disable</option>';
		alertString+='</select>';	
		alertString+='<div id="routeOrangePanel'+alertNum+'">'; // Orange Panel
		alertString+='<table width="100%" style="text-align:left">';
		alertString+='<tr ><td width="20px" rowspan="4" class="panelOrange"></td><td style="text-align:left">Orange level route time (s): </td><td><input id="routeOrangeValue'+alertNum+'" name="routeOrangeValue'+alertNum+'" size="4" class="button2"  value="0"/>   '; 
		alertString+='<span class="fa fa-info-circle"></span> In seconds. If driving time returned by Google Directions is <b>above</b> that thresold, the Orange alert will be displayed</td></tr>';		
		alertString+='<tr><td style="text-align:left">Orange level icon : </td><td><input id="routeOrangeIcon'+alertNum+'" name="routeOrangeIcon'+alertNum+'" class="button2"   onChange="updatePreview(\'Orange\','+alertNum+');" value="fa fa-automobile"/> ';
		alertString+='Animated : <select id="iconOrangeAnimated'+alertNum+'" name="iconOrangeAnimated'+alertNum+'" onChange="updatePreview(\'Orange\','+alertNum+');" class="button2">';
		alertString+='<option value="true">True</option>';
		alertString+='<option value="false" selected>False</option>';
		alertString+='</select></td></tr>';
		alertString+='<tr><td>Orange level message : </td><td><input id="routeOrangeText'+alertNum+'" size="60" name="routeOrangeText'+alertNum+'" class="button2"   onChange="updatePreview(\'Orange\','+alertNum+');" value="Orange Alert Message %T to travel (%S s)"/><br/>  '; 
		alertString+='<span class="fa fa-info-circle"></span> You can use %T for driving time in seconds and %S for driving time as text return by google (e.g. 2 min).</td></tr>';	
		alertString+='<tr><td>Orange Alert preview : </td><td class="previewPanel"><span id="previewAlertOrangeIcon'+alertNum+'" class="alertOrange fa fa-automobile">&nbsp;</span><span id="previewAlertOrangeText'+alertNum+'"> Route'+alertNum+': Orange Alert Message 2 min to travel (100 s)</span></td></tr>';
		alertString+='</table><br/></div>'; // end of Orange panel
		// end of Orange Alert
		// Red Alert
		alertString+='<b>Red level alert:</b>  ';
		alertString+='<select id="routeRedActive'+alertNum+'" name="routeRedActive'+alertNum+'" onChange="$(\'#routeRedPanel'+alertNum+'\').toggle();" class="button2">';
		alertString+='<option value="true" selected>Enabled</option>';
		alertString+='<option value="false">Disable</option>';
		alertString+='</select>';	
		alertString+='<div id="routeRedPanel'+alertNum+'">'; // Red Panel
		alertString+='<table width="100%" style="text-align:left">';
		alertString+='<tr ><td width="20px" rowspan="4" class="panelRed"></td><td style="text-align:left">Red level route time (s): </td><td><input id="routeRedValue'+alertNum+'" name="routeRedValue'+alertNum+'" size="4" class="button2"  value="0"/>   '; 
		alertString+='<span class="fa fa-info-circle"></span> In seconds. If driving time returned by Google Directions is <b>above</b> that thresold, the Red alert will be displayed</td></tr>';		
		alertString+='<tr><td style="text-align:left">Red level icon : </td><td><input id="routeRedIcon'+alertNum+'" name="routeRedIcon'+alertNum+'" class="button2"   onChange="updatePreview(\'Red\','+alertNum+');" value="fa fa-automobile"/> ';
		alertString+='Animated : <select id="iconRedAnimated'+alertNum+'" name="iconRedAnimated'+alertNum+'" onChange="updatePreview(\'Red\','+alertNum+');" class="button2">';
		alertString+='<option value="true">True</option>';
		alertString+='<option value="false" selected>False</option>';
		alertString+='</select></td></tr>';
		alertString+='<tr><td>Red level message : </td><td><input id="routeRedText'+alertNum+'" size="60" name="routeRedText'+alertNum+'" class="button2"   onChange="updatePreview(\'Red\','+alertNum+');" value="Red Alert Message %T to travel (%S s)"/><br/>  '; 
		alertString+='<span class="fa fa-info-circle"></span> You can use %T for driving time in seconds and %S for driving time as text return by google (e.g. 2 min).</td></tr>';	
		alertString+='<tr><td>Red Alert preview : </td><td class="previewPanel"><span id="previewAlertRedIcon'+alertNum+'" class="alertRed fa fa-automobile">&nbsp;</span><span id="previewAlertRedText'+alertNum+'"> Route'+alertNum+': Red Alert Message 2 min to travel (100 s)</span></td></tr>';
		alertString+='</table><br/></div>'; // end of Red panel
		// end of Red Alert
		
		alertString+='</div>'; // end of route panel 
		alertString+='</div>';
		//alert(alertString);
		if(alertNum>1){
				$('#deleteAlert'+(alertNum-1)).hide();
			}
		$('#alertsPanel').append(alertString); 
		$('#numTrafficAlerts').val(alertNum);
		initMap(alertNum);
	}	
	</script>
		<div id="main_top">
			<?php bodyHeader()?>
			<?php include($baseURL."menu.php");?>
		</div>
		<div id="main" style="text-align:justify">
			<h1>Traffic Alert - Setup</h1>
			<div style="width:98%;margin:0 auto">
				<p>
					In this setup you can enable/disable various traffic alerts. If an alert is enabled, you also specify some threshold driving time which will activate the alert. If an alert is enabled and triggered , the specified message will appear on the page.
				</p>
				<p>
					This block leverages Google Maps Directions service to check if the current driving time for specific route is above the thresold you defined.<br/>
					If so, the corresponding alert (Orange or Red) is displayed and the user can check the corresponding map with traffic layer (optional).	<br/>
					For each alert, you define the coordinates of the starting and ending locations (ensure that a route is possible between the two), the normal time it takes to drive between these locations and the thresold for Orange and Red Alert.<br/>
					You can also let your users know that everything is fine by setting a Green alert, trigerred when the driving time is below the normal driving time.<br/>
					You can define as many alerts as you want but you may want to limit the total number to 3-5 max to avoid overwhelming your users with information.
				</p>
				<p>
					One more important thing! If there are no messages to display at all, the block will completely DISAPPEAR from the homepage, so you will never see a blank block.
				</p>
			</div>
			<form method="POST" action="saveSettings.php" target="_blank">
				<div style="width:98%;margin:0 auto">
					<h3>Block heading</h3>
					<br>
					<div style="width:100%;margin:0 auto;text-align:left">
						<input name="trafficAlertHeading" value="<?php echo $trafficAlertHeading?>" class="button2"> Leave blank if you want no heading
					</div>
					<br><br>
					<div style="width:100%;margin:0 auto;text-align:left"><span class="button2" onclick="addAlert();">&nbsp;&nbsp;&nbsp;&nbsp;Add an alert&nbsp;&nbsp;&nbsp;&nbsp;</span>&nbsp;&nbsp;&nbsp;&nbsp;<input type="submit" value="Save" class="button2"></div>
					<input type="hidden" id="numTrafficAlerts" name="numTrafficAlerts" value="0"/>
					<br/>
					<div id="alertsPanel">
					</div>
					<div style="width:50%;text-align:center;margin:0 auto">
						<span class="button2" onclick="addAlert();">&nbsp;&nbsp;&nbsp;&nbsp;Add an alert&nbsp;&nbsp;&nbsp;&nbsp;</span>&nbsp;&nbsp;&nbsp;&nbsp;<input type="submit" value="Save" class="button2">
					</div>
					<br><br>
				</div>
			</form>
		</div>
		<?php include($baseURL."footer.php");?>
		<script>
		$(document).ready(function() {
		  <?php if($numTrafficAlerts>0) {?>          
			loadAlerts();		 
		  <?php } ?>
      })
		</script>
	</body>
</html>