<?php

	
	// load core files
	include("../../../config.php");
	include("../../../css/design.php");
	include("../../../scripts/functions.php");

	
	$languageRaw = file_get_contents($baseURL."lang/gb.php");
	$language['gb'] = json_decode($languageRaw,true);
	$languageRaw = file_get_contents($baseURL."lang/".$lang.".php");
	$language[$lang] = json_decode($languageRaw,true);
	
		// load theme
	$designTheme = json_decode(file_get_contents("../../css/theme.txt"),true);
	$theme = $designTheme['theme'];

?>
		<style>

		.alertGreen{
			color:#00ff00;
		}
		.alertOrange{
			color:#ffa500;
		}
		.alertRed{
			color:#ff0000;
		}
		@-webkit-keyframes trafficAlertAnimation {
		    0% {
				-webkit-transform: scale(0.7, 0.7); opacity: 0.6;
			}
		    50% {
				opacity: 1.0;
				-webkit-transform: scale(1.2, 1.2);
			}
		    100% {
				-webkit-transform: scale(0.7, 0.7); opacity: 0.6;
			}
		}
		@keyframes trafficAlertAnimation {
		    0% {
				-webkit-transform: scale(0.7, 0.7); opacity: 0.6;
				transform: scale(0.7, 0.7); opacity: 0.6;
			}
		    50% {
				opacity: 1.0;
				-webkit-transform: scale(1.2, 1.2);
				transform: scale(1.2, 1.2);
			}
		    100% {
				-webkit-transform: scale(0.7, 0.7); opacity: 0.6;
				transform: scale(0.7, 0.7); opacity: 0.6;
			}
		}
		.trafficAlertAnimationClass{
			-webkit-animation: trafficAlertAnimation 5s ease-out;
	    	-webkit-animation-iteration-count: infinite;
			animation: trafficAlertAnimation 5s ease-out;
	    	animation-iteration-count: infinite;
		}
		.tdalert {
			text-align:left;
			vertical-align:middle;
			padding-left:10px;
		}
		
		.alertMessage{

		}
		#trafficAlertBlock{
			display:none;
		}
		.mapPanel {
			width: 98%;
			height: 450px;
			margin: 20px auto;
			border: 2px solid white;
			border-radius: 10px;			
		}
		hr {
			border:none;
			border-top:1px dashed;
		    height:1px;
		    width:65%;
}
		</style>
		
	<script>
	var vars = {};
	var alertStrings = {};
	var maps = {};
	var routes = {};
	var directions = {};
	var markers = {};
	var alertMaps = {};
	var alertsProcessed=0;
	var numAlertsDisplayed = 0;
	var alertsActive = 0;
	<?php
		// check if settings already exists and if so, load it, otherwise set parameters to default values
	if(file_exists("settings.txt")){
		$variables = json_decode(file_get_contents("settings.txt"),true);
	}
    ?>
	function loadAlerts(){
	$(".alertMessage").css("color","<?php echo $theme=="dark" ? '#fff' : '#000';?>");
	<?php	
	if(file_exists("routes.txt")){
		$cache = json_decode(file_get_contents("routes.txt"),true);
		foreach($cache as $key=>$value){		
			echo 'vars[\''.$key.'\'] = \''.$value.'\';'.PHP_EOL;		
		}
	}

	foreach($variables as $key=>$value){
		${$key} = $value;
		echo 'vars[\''.$key.'\'] = \''.$value.'\';'.PHP_EOL;		
	}
	
		
	
	
	
	if (isset($_GET['action'])) {			
		$action = $_GET['action'];
	}
	else{
		$action ='';
	}
	
	$alertsActive = 0;
	
	if ($action!='') {
		for ($i = 1; $i <= $variables["numTrafficAlerts"]; $i++) {
			if ($variables["routeName".$i]==$action) {
				
		      echo 'ga(\'send\', \'event\', \'TrafficAlert\', \'Action\', \''.$action.'\');'.PHP_EOL;
			  echo '//Action = route name'.$action.PHP_EOL;	 
			  echo 'vars[\'routeActive'.$i.'\']=\'true\';'.PHP_EOL;	
			  echo 'vars[\'routeMapActive'.$i.'\']=\'alertFixed\';'.PHP_EOL;				  
			  echo 'vars[\'routeGreenActive'.$i.'\']=\'true\';'.PHP_EOL;
			  echo 'vars[\'routeOrangeActive'.$i.'\']=\'true\';'.PHP_EOL;
			  echo 'vars[\'routeRedActive'.$i.'\']=\'true\';'.PHP_EOL;
			  echo 'addAlert('.$i.');';	
			  $alertsActive++; 
			} 
						
		}
		
		
	}

	
	if ($alertsActive==0) {
		
		for ($i = 1; $i <= $variables["numTrafficAlerts"]; $i++) {
				if ($variables["routeActive".$i]=='true') {	
				  	
				  $alertsActive++;
				} 
			}
			echo 'var alertsActive='.$alertsActive.';'.PHP_EOL;	
			for ($i = 1; $i <= $variables["numTrafficAlerts"]; $i++) {
				if ($variables["routeActive".$i]=='true') {				  
				  echo 'addAlert('.$i.');';					  
				} 
			}
	}
	else {
		for ($i = 1; $i <= $variables["numTrafficAlerts"]; $i++) {
			if ($variables["routeName".$i]!=$action) {
				echo 'vars[\'routeActive'.$i.'\']=\'false\';'.PHP_EOL;	
			}
		}
		echo 'var alertsActive='.$alertsActive.';'.PHP_EOL;	
	}
		
	
	?>
	}
	<?php echo 'var alertsActive='.$alertsActive.';'.PHP_EOL;	?>
	
	function initMap(myAlertNum) {	     
	//  console.log('Adding map to '+'routeMapPanel'+myAlertNum);
	  var map = new google.maps.Map(document.getElementById('routeMapPanel'+myAlertNum), 
		  {
		  zoom: Number(vars['zoomMap'+myAlertNum]),
          center: {
              lat: Number(vars['centerMapLat'+myAlertNum]),
              lng: Number(vars['centerMapLong'+myAlertNum])
          }
		});
		google.maps.event.addListenerOnce(map, 'idle', function(){
			//console.log('Map'+myAlertNum+' fully loaded');
		
		
		var trafficLayer = new google.maps.TrafficLayer();
		trafficLayer.setMap(map);
		
		if (vars['showRoute'+myAlertNum]=='true') {
			keyRoute = 'route'+myAlertNum;
			if (keyRoute in routes) {
				directionsDisplay = new google.maps.DirectionsRenderer({suppressMarkers: true});
				directionsDisplay.setDirections(routes['route'+myAlertNum]);		
				directionsDisplay.setMap(map);
				directions['directions'+myAlertNum]=directionsDisplay;	
			}			
		}
				
		/*var iconCenter = {
			url: 'icons/center.png', // url
			scaledSize: new google.maps.Size(25, 25), // scaled size
			origin: new google.maps.Point(0,0), // origin
			anchor: new google.maps.Point(12, 12) // anchor
		};*/

		var iconStart = new google.maps.MarkerImage("https://chart.apis.google.com/chart?chst=d_map_pin_letter&chld=S|00FF00",
        new google.maps.Size(21, 34),
        new google.maps.Point(0,0),
        new google.maps.Point(10, 34)
		);
		
		var iconFinish = new google.maps.MarkerImage("https://chart.apis.google.com/chart?chst=d_map_pin_letter&chld=F|FF0000",
        new google.maps.Size(21, 34),
        new google.maps.Point(0,0),
        new google.maps.Point(10, 34)
		);		
		
		
		var markerStart = new google.maps.Marker({
		  icon : iconStart,		  
          position:  {
              lat: Number(vars['routeOriginLat'+myAlertNum]),
              lng: Number(vars['routeOriginLng'+myAlertNum])
		  },
          map: map,
          title: 'Origin'
        });
		markers['markerStart'+myAlertNum]=markerStart;
		
		var markerFinish = new google.maps.Marker({
		  icon : iconFinish,		  
          position:  {
              lat: Number(vars['routeDestinationLat'+myAlertNum]),
              lng: Number(vars['routeDestinationLng'+myAlertNum])
		  },
          map: map,
          title: 'Destination'
        });
		markers['markerFinish'+myAlertNum]=markerFinish;
		
		});
		
		maps['map'+myAlertNum]=map;	
		
		
	}
	
	function refreshMap(myAlertNum){
		google.maps.event.trigger(maps['map'+myAlertNum], 'resize');
		maps['map'+myAlertNum].setZoom(Number(vars['zoomMap'+myAlertNum]));		
		maps['map'+myAlertNum].setCenter({
			lat: Number(vars['centerMapLat'+myAlertNum]),
            lng: Number(vars['centerMapLong'+myAlertNum])
			})
	}
	
	
	  function formatAlert(myTimeSecond, myTimeText, myAlertColor, myAlertNum) {		
		  myMessage = '<tr><td class="tdalert" style="text-align:right;"><span class="alert'+myAlertColor;
		  if (vars['icon'+myAlertColor+'Animated'+myAlertNum]=='true') myMessage += ' trafficAlertAnimationClass';
		  myMessage +=' '+vars['route'+myAlertColor+'Icon'+myAlertNum]+'"></span></td><td class="tdalert" style="text-align:left;">';
		  textValue = vars['route'+myAlertColor+'Text'+myAlertNum];
		  textValue = textValue.replace('%T', myTimeText);
		  textValue = textValue.replace('%S', myTimeSecond);
		  myMessage +='<span> '+vars['routeName'+myAlertNum] + ': ' + textValue+'</span></td></tr>'	 
      return myMessage;
  }
   function displayAlerts(){
	  // console.log('Displaying alerts');
	   alertsDisplayed = 0;
	   finalString='<table style="margin: 0 auto;">';
	   if (vars['trafficAlertHeading'].length>0) finalString+='<tr><td colspan="2" style=text-align:center"><h2>'+vars['trafficAlertHeading']+'</h2></td></tr>';
	   for (i=1;i<=Number(vars['numTrafficAlerts']);i++) {
			if (vars['routeActive'+i]=='true')	{ 
				if (typeof alertStrings['routeName'+i] !== 'undefined') {
					if (alertStrings['routeName'+i].length>0)	{
						finalString += alertStrings['routeName'+i];						
						//console.log('Alert displayed'+i);
						alertsDisplayed++;						
						if (alertsDisplayed<numAlertsDisplayed) finalString += '<tr><td colspan="2"><hr></tr></td>';
					} //else console.log('Route '+i+ ' alertString = 0');
				}// else console.log('Route '+i+ ' is does not have alertString');			
			} //else console.log('Route '+i+ ' is not active');
	   }
	   finalString+='</table>';
	   if (alertsDisplayed>0) {
		   $('#trafficAlertPanel').html(finalString);
		   $('#trafficAlertBlock').show();
	   }
		else {
			$('#trafficAlertBlock').hide();
		}	   
   }
   
   function displayMaps(){	   
	   for (i=1;i<=Number(vars['numTrafficAlerts']);i++) {
			if (vars['routeActive'+i]=='true')	{ 
				if (typeof alertMaps['route'+i] !== 'undefined') {
					if (alertMaps['route'+i].length>0)	{
						initMap(i);
						//console.log('Displaying Map '+i);
					}
				}			
			}
	   }	   
   }
   
   
   function processAlert(alertNum,routeTimeSecond,routeTimeString){

                 var trafficAlertTriggered = false;
				 var alertString='';
				  
				  
				 // console.log('Tiempo route '+vars['routeName'+alertNum]+' = '+routeTimeSecond);	
				//  routeTimeSecond=3;
				//  routeTimeString='54';
				if (vars['routeGreenActive'+alertNum]=='true') {
					if (routeTimeSecond<=Number(vars['routeGreenValue'+alertNum])){
						alertString=formatAlert(routeTimeSecond, routeTimeString, 'Green', alertNum);
						trafficAlertTriggered=true;
					}
				}
				if (vars['routeOrangeActive'+alertNum]=='true') {
					if (routeTimeSecond>Number(vars['routeOrangeValue'+alertNum])){
						alertString=formatAlert(routeTimeSecond, routeTimeString, 'Orange', alertNum);
						trafficAlertTriggered=true;
					}
				}
				if (vars['routeRedActive'+alertNum]=='true') {
					if (routeTimeSecond>Number(vars['routeRedValue'+alertNum])){
						alertString=formatAlert(routeTimeSecond, routeTimeString, 'Red', alertNum);
						trafficAlertTriggered=true;
					}
				}
				//console.log('TrafficalertTriggered'+trafficAlertTriggered);
				
				if (trafficAlertTriggered) {
					numAlertsDisplayed++;					
					alertStrings['routeName'+alertNum]=alertString;
					if (vars['routeMapActive'+alertNum]=='disabled') {
						// displayAlerts();	
					}
					else{
					mapString = '';
					if (vars['routeMapActive'+alertNum]=='alertDetails') {
						mapString +='<tr><td colspan="2" style="text-align:center;">';
						mapString +='<span class="more" onclick="txt = $(\'#routeMapPanel'+alertNum+'\').is(\':visible\') ? \'<?php echo lang('details','l')?>\' : \'<?php echo lang('hide','l')?>\';$(\'#routeMapPanel'+alertNum+'\').toggle();$(this).text(txt);refreshMap('+alertNum+');">';
						mapString +='<?php echo lang('details','l')?>';
						mapString +='</span></td></tr>';	
						mapString +='<tr><td class="tdalert" colspan="2"><div  class="mapPanel" id="routeMapPanel'+alertNum+'" style="display:none;">here is the map</div></td></tr>';
					}
					else {
						mapString +='<tr><td class="tdalert" colspan="2"><div class="mapPanel" id="routeMapPanel'+alertNum+'">here is the map</div></td></tr>';
					}	
					alertStrings['routeName'+alertNum]+=mapString;					
					// displayAlerts();					
					//console.log('Map will be displayed for Route '+alertNum);
					alertMaps['route'+alertNum]='true'; 
					//initMap(alertNum);
					
					
					}		  
				}
				else{
					// Display fixed
					
			   }		
			   
			     alertsProcessed++;
				// console.log('alertsProcessed '+alertsProcessed+' / '+alertsActive);
			      if (alertsProcessed==alertsActive){				  
					displayAlerts();							
					displayMaps();					  
				  }
   }
	
	function addAlert(alertNum) {
	  var trafficAlertTriggered = false;
	  var alertString='';
	  processedFromCache=false;
	  currentRouteName = vars['routeName'+alertNum];
	  keyName = currentRouteName+'Name';
	  console.log('Looking for var '+keyName); 
	  if (keyName in vars) {
		  
		  currentTime = new Date().getTime();
		  currentTime = Math.floor(currentTime/1000);
		  updatedTime = parseInt(vars[currentRouteName+'Update'],10);
		  keyDelay = 'routeName'+alertNum+'CacheDelay'; // implement in setup
		  maxDelay = 300;
		  if (keyDelay in vars) {
			  maxDelay = parseInt(vars[keyDelay])*60;
		  }
		  delay = currentTime-updatedTime;	
		  routeTimeSecond=vars[currentRouteName+'Value'];
		  routeTimeString=vars[currentRouteName+'Text'];
		  if (delay<maxDelay) {
		  console.log(currentRouteName+' will be processed from cache '+ routeTimeSecond+ ' = '+routeTimeString+' updated '+delay+' < '+maxDelay);
		  processAlert(alertNum,Number(routeTimeSecond),routeTimeString);
		  processedFromCache=true;
		  }
		  else{
			console.log(currentRouteName+' will NOT be processed from cache '+ routeTimeSecond+ ' = '+routeTimeString+' updated '+delay+' > '+maxDelay);  
		  }
	  }
	  else {
		  console.log('Not found in vars : '+keyName);
	  }
	  
	  if (!processedFromCache) {
	  console.log(currentRouteName+' will be retrieved from Google');
      var directionsService = new google.maps.DirectionsService();

      directionsService.route({
		  
		  origin: {
              lat: Number(vars['routeOriginLat'+alertNum]),
              lng: Number(vars['routeOriginLng'+alertNum])
			},
			destination: {
              lat: Number(vars['routeDestinationLat'+alertNum]),
              lng: Number(vars['routeDestinationLng'+alertNum])
			},
              travelMode: "DRIVING",
			  durationInTraffic: true
          },
          function(response, status) {
              if (status === google.maps.DirectionsStatus.OK) {
				  routes['route'+alertNum]=response;
                  routeTimeSecond = response.routes[0].legs[0].duration_in_traffic.value;
                  routeTimeString = response.routes[0].legs[0].duration_in_traffic.text;	
				   cacheUrl = '<?php echo $pageURL.$path?>/homepage/blocks/trafficAlert/cacheRoute.php';		
				//  console.log('Response = '+json_encode(response));
				  $.ajax({
							url: cacheUrl,
							data: { 
								"name": vars['routeName'+alertNum], 
								"value": routeTimeSecond, 
								"text": routeTimeString								
							},
							cache: false,
							type: "POST",
							success: function(response) {
								console.log(response);

							},
							error: function(xhr) {
								console.log('Error calling url '+cacheUrl);

							}
						});
				  
				  processAlert(alertNum,routeTimeSecond,routeTimeString);
                  }
                  else {
                      console.log('Error loading google maps: ' + status);
                  }
				
              });
	  }			  
      }
	  
	 // end of block code
	 
	
	
	</script>



		<div id="trafficAlertPanel" class="alertMessage" style="text-align:center"></div>

		<script>
		$(document).ready(function() {
		//  $('#trafficAlertBlock').show();
		  <?php if($numTrafficAlerts>0) {?>   
			//console.log('Loading alerts');		  
			loadAlerts();			
		  <?php } ?>
      })
		</script>
