<?php

	// check acces authorization
	session_start();
	/*if($_SESSION['user']!="admin"){
		echo "Unauthorized access.";
		die();
	}*/
	
	// load core files
	include("../../../config.php");
	include("../../../css/design.php");
	include("../../../header.php");
	
	$languageRaw = file_get_contents($baseURL."lang/gb.php");
	$language['gb'] = json_decode($languageRaw,true);
	$languageRaw = file_get_contents($baseURL."lang/".$lang.".php");
	$language[$lang] = json_decode($languageRaw,true);
	
		// load theme
	$designTheme = json_decode(file_get_contents("../../css/theme.txt"),true);
	$theme = $designTheme['theme'];

?>
<!DOCTYPE html>
<html>
	<head>
		<title><?php echo $pageName?></title>
		<?php metaHeader()?>
		<style>

		.alertGreen{
			color:#00ff00;
		}
		.alertOrange{
			color:#ffa500;
		}
		.alertRed{
			color:#ff0000;
		}
		@-webkit-keyframes trafficAlertAnimation {
		    0% {
				-webkit-transform: scale(0.7, 0.7); opacity: 0.6;
			}
		    50% {
				opacity: 1.0;
				-webkit-transform: scale(1.2, 1.2);
			}
		    100% {
				-webkit-transform: scale(0.7, 0.7); opacity: 0.6;
			}
		}
		@keyframes trafficAlertAnimation {
		    0% {
				-webkit-transform: scale(0.7, 0.7); opacity: 0.6;
				transform: scale(0.7, 0.7); opacity: 0.6;
			}
		    50% {
				opacity: 1.0;
				-webkit-transform: scale(1.2, 1.2);
				transform: scale(1.2, 1.2);
			}
		    100% {
				-webkit-transform: scale(0.7, 0.7); opacity: 0.6;
				transform: scale(0.7, 0.7); opacity: 0.6;
			}
		}
		.trafficAlertAnimationClass{
			-webkit-animation: trafficAlertAnimation 5s ease-out;
	    	-webkit-animation-iteration-count: infinite;
			animation: trafficAlertAnimation 5s ease-out;
	    	animation-iteration-count: infinite;
		}
		td {
			text-align:left;
			vertical-align:middle;
			padding-left:10px;
		}
		
		.alertMessage{
		font-size: 1.2em;
		}
		
		.mapPanel {
			width: 98%;
			height: 600px;
			margin: 20px auto;
			border: 2px solid white;
			border-radius: 10px;			
		}
		</style>
		<script src="https://maps.googleapis.com/maps/api/js?key=<?php echo $googleMapsAPIKey?>"></script>	
	</head>
	<body>
	
	<script>
	var vars = {};
	var alertStrings = {};
	var maps = {};
	var routes = {};
	var directions = {};
	var markers = {};
	var alertMaps = {};
	var alertsProcessed=0;
	<?php
		// check if settings already exists and if so, load it, otherwise set parameters to default values
	if(file_exists("settings.txt")){
		$variables = json_decode(file_get_contents("settings.txt"),true);
	}
    ?>
	function loadAlerts(){
	$(".alertMessage").css("color","<?php echo $theme=="dark" ? '#fff' : '#000';?>");
	<?php	
	

	foreach($variables as $key=>$value){
		${$key} = $value;
		echo 'vars[\''.$key.'\'] = \''.$value.'\';'.PHP_EOL;		
	}
	for ($i = 1; $i <= $variables["numTrafficAlerts"]; $i++) {
		if ($variables["routeActive".$i]=='true') {
		  echo 'addAlert('.$i.');';	
		} 
	}
	
	?>
	}
	
	
	function initMap(myAlertNum) {	     
	  console.log('Adding map to '+'routeMapPanel'+myAlertNum);
	  var map = new google.maps.Map(document.getElementById('routeMapPanel'+myAlertNum), 
		  {
		  zoom: Number(vars['zoomMap'+myAlertNum]),
          center: {
              lat: Number(vars['centerMapLat'+myAlertNum]),
              lng: Number(vars['centerMapLong'+myAlertNum])
          }
		});
		google.maps.event.addListenerOnce(map, 'idle', function(){
			console.log('Map'+myAlertNum+' fully loaded');
		
		
		var trafficLayer = new google.maps.TrafficLayer();
		trafficLayer.setMap(map);
		
		if (vars['showRoute'+myAlertNum]=='true') {
			directionsDisplay = new google.maps.DirectionsRenderer({suppressMarkers: true});
			directionsDisplay.setDirections(routes['route'+myAlertNum]);		
			directionsDisplay.setMap(map);
			directions['directions'+myAlertNum]=directionsDisplay;		
		}
				
		/*var iconCenter = {
			url: 'icons/center.png', // url
			scaledSize: new google.maps.Size(25, 25), // scaled size
			origin: new google.maps.Point(0,0), // origin
			anchor: new google.maps.Point(12, 12) // anchor
		};*/

		var iconStart = new google.maps.MarkerImage("https://chart.apis.google.com/chart?chst=d_map_pin_letter&chld=S|00FF00",
        new google.maps.Size(21, 34),
        new google.maps.Point(0,0),
        new google.maps.Point(10, 34)
		);
		
		var iconFinish = new google.maps.MarkerImage("https://chart.apis.google.com/chart?chst=d_map_pin_letter&chld=F|FF0000",
        new google.maps.Size(21, 34),
        new google.maps.Point(0,0),
        new google.maps.Point(10, 34)
		);		
		
		
		var markerStart = new google.maps.Marker({
		  icon : iconStart,		  
          position:  {
              lat: Number(vars['routeOriginLat'+myAlertNum]),
              lng: Number(vars['routeOriginLng'+myAlertNum])
		  },
          map: map,
          title: 'Origin'
        });
		markers['markerStart'+myAlertNum]=markerStart;
		
		var markerFinish = new google.maps.Marker({
		  icon : iconFinish,		  
          position:  {
              lat: Number(vars['routeDestinationLat'+myAlertNum]),
              lng: Number(vars['routeDestinationLng'+myAlertNum])
		  },
          map: map,
          title: 'Destination'
        });
		markers['markerFinish'+myAlertNum]=markerFinish;
		
		});
		
		maps['map'+myAlertNum]=map;	
		
		
	}
	
	function refreshMap(myAlertNum){
		google.maps.event.trigger(maps['map'+myAlertNum], 'resize');
		maps['map'+myAlertNum].setZoom(Number(vars['zoomMap'+myAlertNum]));		
		maps['map'+myAlertNum].setCenter({
			lat: Number(vars['centerMapLat'+myAlertNum]),
            lng: Number(vars['centerMapLong'+myAlertNum])
			})
	}
	
	
	  function formatAlert(myTimeSecond, myTimeText, myAlertColor, myAlertNum) {		
		  myMessage = '<tr><td style="text-align:right;"><span class="alert'+myAlertColor;
		  if (vars['icon'+myAlertColor+'Animated'+myAlertNum]=='true') myMessage += ' trafficAlertAnimationClass';
		  myMessage +=' '+vars['route'+myAlertColor+'Icon'+myAlertNum]+'"></span></td><td style="text-align:left;">';
		  textValue = vars['route'+myAlertColor+'Text'+myAlertNum];
		  textValue = textValue.replace('%T', myTimeText);
		  textValue = textValue.replace('%S', myTimeSecond);
		  myMessage +='<span> '+vars['routeName'+myAlertNum] + ': ' + textValue+'</span></td></tr>'	 
      return myMessage;
  }
   function displayAlerts(){
	   alertsDisplayed = 0;
	   finalString='<table style="margin: 0 auto;" border="1">';
	   if (vars['trafficAlertHeading'].length>0) finalString+='<tr><td colspan="2" style=text-align:center"><h2>'+vars['trafficAlertHeading']+'</h2></td></tr>';
	   for (i=1;i<=Number(vars['numTrafficAlerts']);i++) {
			if (vars['routeActive'+i]=='true')	{ 
				if (typeof alertStrings['routeName'+i] !== 'undefined') {
					if (alertStrings['routeName'+i].length>0)	{
						finalString += alertStrings['routeName'+i];
						console.log('Alert displayed'+i);
						alertsDisplayed++;
					}
				}			
			}
	   }
	   finalString+='</table>';
	   if (alertsDisplayed>0) {
		   $('#trafficAlertPanel').html(finalString);
		   $('#trafficAlertBlock').show();
	   }
		else {
			$('#trafficAlertBlock').hide();
		}	   
   }
   
   function displayMaps(){	   
	   for (i=1;i<=Number(vars['numTrafficAlerts']);i++) {
			if (vars['routeActive'+i]=='true')	{ 
				if (typeof alertMaps['route'+i] !== 'undefined') {
					if (alertMaps['route'+i].length>0)	{
						initMap(i);
						console.log('Displaying Map '+i);
					}
				}			
			}
	   }	   
   }
	
	function addAlert(alertNum) {
	  var trafficAlertTriggered = false;
	  var alertString='';
      var directionsService = new google.maps.DirectionsService();

      directionsService.route({
		  
		  origin: {
              lat: Number(vars['routeOriginLat'+alertNum]),
              lng: Number(vars['routeOriginLng'+alertNum])
			},
			destination: {
              lat: Number(vars['routeDestinationLat'+alertNum]),
              lng: Number(vars['routeDestinationLng'+alertNum])
			},
              travelMode: "DRIVING",
			  durationInTraffic: true
          },
          function(response, status) {
              if (status === google.maps.DirectionsStatus.OK) {
				  routes['route'+alertNum]=response;
                  routeTimeSecond = response.routes[0].legs[0].duration_in_traffic.value;
                  routeTimeString = response.routes[0].legs[0].duration_in_traffic.text;				  
				  console.log('Tiempo route '+vars['routeName'+alertNum]+' = '+routeTimeSecond);	
				//  routeTimeSecond=3;
				//  routeTimeString='54';
				if (vars['routeGreenActive'+alertNum]=='true') {
					if (routeTimeSecond<=Number(vars['routeGreenValue'+alertNum])){
						alertString=formatAlert(routeTimeSecond, routeTimeString, 'Green', alertNum);
						trafficAlertTriggered=true;
					}
				}
				if (vars['routeOrangeActive'+alertNum]=='true') {
					if (routeTimeSecond>Number(vars['routeOrangeValue'+alertNum])){
						alertString=formatAlert(routeTimeSecond, routeTimeString, 'Orange', alertNum);
						trafficAlertTriggered=true;
					}
				}
				if (vars['routeRedActive'+alertNum]=='true') {
					if (routeTimeSecond>Number(vars['routeRedValue'+alertNum])){
						alertString=formatAlert(routeTimeSecond, routeTimeString, 'Red', alertNum);
						trafficAlertTriggered=true;
					}
				}
				
				if (trafficAlertTriggered) {
										
					alertStrings['routeName'+alertNum]=alertString;
					if (vars['routeMapActive'+alertNum]=='disabled') {
						// displayAlerts();	
					}
					else{
					mapString = '';
					if (vars['routeMapActive'+alertNum]=='alertDetails') {
						mapString +='<tr><td colspan="2" style="text-align:center;">';
						mapString +='<span class="more" onclick="txt = $(\'#routeMapPanel'+alertNum+'\').is(\':visible\') ? \'<?php echo lang('details','l')?>\' : \'<?php echo lang('hide','l')?>\';$(\'#routeMapPanel'+alertNum+'\').toggle();$(this).text(txt);refreshMap('+alertNum+');">';
						mapString +='<?php echo lang('details','l')?>';
						mapString +='</span></td></tr>';	
						mapString +='<tr><td colspan="2"><div  class="mapPanel" id="routeMapPanel'+alertNum+'" style="display:none;">here is the map</div></td></tr>';
					}
					else {
						mapString +='<tr><td colspan="2"><div class="mapPanel" id="routeMapPanel'+alertNum+'">here is the map</div></td></tr>';
					}	
					alertStrings['routeName'+alertNum]+=mapString;					
					// displayAlerts();					
					console.log('Map will be displayed for Route '+alertNum);
					alertMaps['route'+alertNum]='true'; 
					//initMap(alertNum);
					
					
					}		  
				}
				else{
					// do nothing
			   }
                  }
                  else {
                      console.log('Error loading google maps: ' + status);
                  }
				  alertsProcessed++;
				  console.log('Alerts processed'+alertsProcessed);
				  if (alertsProcessed==Number(vars['numTrafficAlerts'])){
					console.log('Displaying alerts');
					displayAlerts();
					console.log('Displaying maps');			
					displayMaps();					  
				  }
              });			  
      }
	  
	 // end of block code
	 
	
	
	</script>
		<div id="main_top">
			<?php bodyHeader()?>
			<?php include($baseURL."menu.php");?>
		</div>
		<div id="main" style="text-align:justify">

		<div id="trafficAlertPanel" class="alertMessage" style="text-align:center"></div>

		</div>		
		<?php include($baseURL."footer.php");?>
		<script>
		$(document).ready(function() {
		  $('#trafficAlertBlock').show();
		  <?php if($numTrafficAlerts>0) {?>   
			console.log('Loading alerts');		  
			loadAlerts();			
		  <?php } ?>
      })
		</script>
	</body>
</html>